<?php

/**
 * ZIP-AES Example Project
 * =======================
 * Created by Mattias Sandström <msa@tangix.com> as an illustration
 * to the REALbasic Developer Article
 *
 * Free for all use
 *
 */

// ------------------------------------------------------------
// Create the ZIP-file
// ------------------------------------------------------------

function str_rand($length = 8, $seeds = 'abcdefghijklmnopqrstuvwxyz0123456789')
{
	$str = '';
	$seeds_count = strlen($seeds);

	// Seed
	list($usec, $sec) = explode(' ', microtime());
	$seed = (float) $sec + ((float) $usec * 100000);
	mt_srand($seed);

	// Generate
	for ($i = 0; $length > $i; $i++) {
		$str .= substr($seeds, mt_rand(0, $seeds_count - 1), 1);
	}

	return $str;
}

$filename = "rbd_archive_" . str_rand(5) . ".zip";
$dest_file = sys_get_temp_dir() . "/" . $filename;

if (!method_exists('ZipArchive', 'open')) {
	echo "Error: ZipArchive function not enabled";
	exit;
}

$dest_zip = new ZipArchive();
if ($dest_zip->open($dest_file, ZIPARCHIVE::CREATE) !== TRUE) {
	exit("cannot open <$dest_file>\n");
}

$dest_zip->addFromString("current_time.txt", "Time at server is: " . date("r"));
$dest_zip->addFile("tangix_logo.png", "tangix_logo.png");
$dest_zip->close();

// ------------------------------------------------------------
// Pad the ZIP with 16 bytes so we are sure that encryption will work
// ------------------------------------------------------------

$fp = fopen($dest_file, "a+");
if (!$fp) {
	echo "FAIL: PADDING_ERROR";
	exit;
}

fwrite($fp, "0123456789ABCDEF");
fclose($fp);


// Perform the encryption of the file
$c = mcrypt_module_open('rijndael-128', '', 'ecb', '');
$ks = mcrypt_enc_get_key_size($c);
$key = "f8eXc64vjvW0oV34u1bobQdR5PNRIrZz";
$iv = "00000000000000000000000000000000";

mcrypt_generic_init($c, $key, $iv);
$result = mcrypt_generic($c, file_get_contents($dest_file));

header("Content-Type: application/binary");
header("Content-Length: " . strlen($result));
header("Content-Disposition: attachment; filename=$filename");
echo $result;

unlink($dest_file);

?>